Kerbal Space Program - Bug #27279

Wings blocks engine exhaust unrealistically.
02/14/2021 06:35 PM - jukkamuhonen@hotmail.com
Description

I noticed that this doesn't count as thrust, as it should. You have to pitch up or down to thrust take effect.
https://steamcommunity.com/app/220200/discussions/0/4956744526896493135/

This bug is brought from steam conversations where someone wondered why this plane doesn't move without pitching up or down.

This is might be bad design of plane but anyways it should work.

History

#1 - 02/14/2021 06:36 PM - jukkamuhonen@hotmail.com

Exhaust/thrust gets blocked on this case by tail wings.

#2 - 02/15/2021 06:33 AM - Dunbaratu

Not sure how to fix this easily without engine thrust magically working anywhere on the ship even inside a closed container. About the only thing | can
think of is instead of one spherecast or raycast out the back of the engine (which | assume is what the check is using), do multiple raycasts - one from
the center and several from the outer ring of the engine nozzle. These multiple points would be sort of a zeitgeist of generally how much of the thrust
is getting blocked. If most of the array of rays misses a thing and only a few hit a thing, then there should be enough exhaust going "around" the
blocking thing that it shouldn't count as a blockage. (So a wing edge-on wouldn't block the exhaust as it splits around it, but hitting the flat of a wing
would because more of the raycasts in the cluster hit the wing that way.)

#3 - 02/15/2021 02:07 PM - jukkamuhonen@hotmail.com

Game engine knows which part blocks it, now it only needs to get it frontal coefficent and its surface area (game engine knows these too) and
substract it from maximum possible coefficent (maybe use value of 2 here at first, change it later if possible.) to get affecting thrust.

#4 - 02/15/2021 02:11 PM - jukkamuhonen@hotmail.com

jukkamuhonen@hotmail.com wrote:

Game knows which part blocks it, now it only needs to get it frontal coefficent and its surface area (game engine knows these too) and substract
it from maximum possible coefficent (maybe use value of 2 here at first, change it later if possible.) to get affecting thrust.
As far as i know Game knows if part is inside of closed container.
Game doesn't calculate engine inside of structucal pipes, but engine still correctly gives thrust.
Other way to make this happen, is not to lower thrust of engines when they get blocked, but increase airflow value for parts it is pointed to, this way
we actually could get more realistic aerodynamics, when engine is blowing fast air to rear winds and you pitch up/down or roll plane. It then adds
engine exhausts as drag, trought affecting parts.
It could be interesting to see results of back wings of rocket/airplane reaching sonic barrier before front does.
#6 - 02/24/2021 12:06 AM - David.Wineinger

- Status changed from New to Confirmed

- % Done changed from 0 to 10

#7 - 02/26/2021 03:14 AM - jukkamuhonen@hotmail.com
If this gonna get fixed, i wonder how this would work on vacuum real life:

If engines are rocket engines which pushes wings at vacuum, would rocket turn because of that or does flow work different way at vacuum? =>
Would flow break up faster or slower than at atmosphere, because of lower air pressure.

My guess is there would be slight turn, but not very big. That's why they uses huge engine bells at vacuum to prevent flow from being eaten away.
